<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<!-- saved from url=(0044)http://www.relib.com/java/files/Map/Map.java -->
<HTML><HEAD>
<META http-equiv=Content-Type content="text/html; charset=windows-1251">
<META content="MSHTML 5.50.4134.600" name=GENERATOR></HEAD>
<BODY><XMP>import java.awt.*;
import java.awt.image.*;
import java.applet.*;
import java.net.*;
import java.io.*;

public class Map extends Applet
{

	int max=100;

	Image map;
	int count;
										   
	Point lPoint[];
	Point rPoint[];

	String mapFile[]=new String[max];
	
	int curId;
	boolean isZoom;

	/**
	 * Initialization.
	 */
	public void init()
	{
		lPoint = new Point[max];
		rPoint = new Point[max];

		getData();
		getMap(mapFile[0]);
	}

	/**
	 * Get file of map picture from URL.
	 */
	private void getMap(String pic)
	{
		map = getImage(getCodeBase(), pic);
		repaint();
		zoomStatus();
	}

	/**
	 * Read the data file Map.dat.
	 */
	protected void getData()
    {
		InputStream is=null;
		int i=0;
		int ix=0;
		int x=0,y=0,w=0,h=0;

		try
		{
		    try
			{
				is = new URL(getCodeBase(), "Map.dat").openStream();
				StreamTokenizer st = new StreamTokenizer(is);

				st.eolIsSignificant(false);
				st.commentChar('#');

				while (st.ttype != StreamTokenizer.TT_EOF)
			    {
					st.nextToken();
					/*
					if(st.ttype == '{')
				    {
				    }

					if(st.ttype == '}')
				    {
				    }
					*/
					if (st.ttype==st.TT_NUMBER)
				    {
						int  n = (int) st.nval;
						switch (i)
					    {
							case 0:
								x = n;
								break;
							case 1:
								y = n;
								break;
							case 2:
								w = n;
								break;
							case 3:
								h = n;
								break;
					    }
						i++;
						if (i==4)
						{
							lPoint[ix] = new Point(x,y);
							rPoint[ix] = new Point(w,h);
							i=0;
						}
						//continue;
				    }

					if(st.ttype==st.TT_WORD)
				    {
						mapFile[ix]=st.sval;
						ix++;
				    }

			    }	/* while */
		    }
			catch (MalformedURLException e) {}
		}
		catch (IOException e) {}
		count=ix;
    }

	public void paint(Graphics g)
	{
		g.drawImage(map,0,0,this);
		g.setColor(Color.black);
		g.drawRect(0,0,size().width-1,size().height-1);
		if (!isZoom & curId!=0)
		{
			g.setColor(Color.red);
			g.drawRect(lPoint[curId].x,lPoint[curId].y,rPoint[curId].x,rPoint[curId].y);
		}
	}

	/**
	 * Show area under mouse pointer.
	 **/
	private void showArea(int i)
	{
		Graphics g = null;
		g = this.getGraphics();
		g.setColor(Color.red);
		g.drawRect(lPoint[i].x,lPoint[i].y,rPoint[i].x,rPoint[i].y);
	}

	/**
	 * Get index of map image.
	 **/
	private int getIndex(int x, int y)
	{
		for (int i=1; i<count; i++)
			if (x>=lPoint[i].x & x<=(lPoint[i].x+rPoint[i].x) & y>=lPoint[i].y & y<=(lPoint[i].y+rPoint[i].y))
				return i;
		return 0;
	}

	public boolean mouseMove(Event evt, int x, int y)
	{
		int i;
		i = getIndex(x,y);
		
		if (!isZoom)
		{
			if (curId != i)
			{
				if (curId != 0)
					repaint(lPoint[curId].x,lPoint[curId].y,rPoint[curId].x+1,rPoint[curId].y+1);
				if (i != 0)
					showArea(i);
				curId = i;
			}
		}
		return true;
	}
		
	/**
	* Update applet.
	**/
	public void update(Graphics g)
	{
		paint(g);
	}
	
	public boolean mouseUp(Event evt, int x, int y)
	{
		if (isZoom)
		{
			isZoom=false;
			getMap(mapFile[0]);
		}
		else
		{
			if (curId == 0)
			{
				showStatus("This area have not zoom.");
			}
			else
			{
				isZoom=true;
				getMap(mapFile[curId]);
			}
		}
		return true;
	}

	/**
	 * Show message in status line.
	 **/
	private void zoomStatus()
	{
		String msg;
		if (isZoom)
			msg="Click for unzoom";
		else
			msg="Click for zoom";
		showStatus(msg);
	}

	/**
	 * Applet Info.
	 **/
	public String getAppletInfo()
	{
	    return "Map, 1999 (C) Alexei Smirnov, http://www.relib.com";
	}
}
</XMP></BODY></HTML>
